############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import ZSI.TC
from pyGridWare.generated.types import GetNSContainer
import pyGridWare.generated.types.WS_BaseNotification_services_types as _BaseNotification
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.properties.ResourceProperties import ResourceProperties

_BaseNotificationTNS = "http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification-1.2-draft-01.xsd"

class SubscriptionKey(int):
    typecode = ZSI.TC.Iint(pname=("http://wsrf.globus.org/",'SubscriptionKey'))



class SubscriptionProperties(ResourceProperties):
    declaration = GetNSContainer(_BaseNotification, _BaseNotificationTNS).SubscriptionManagerRP_Dec
    '''
    SubscriptionManagerRP_Dec
        _CurrentTime
        _TerminationTime
        _ConsumerReference
        _TopicExpression
        _UseNotify
        _Precondition
        _Selector
        _SubscriptionPolicy
        _CreationTime 
    '''


    def __init__(self):
        ResourceProperties.__init__(self)

    def getTopicExpression(self):
        return self._element._TopicExpression
    def setTopicExpression(self, value): 
        #assert isinstance(value, , 'expecting boolean for UseNotify value.'
        self._element._TopicExpression = value
    TopicExpression = property(getTopicExpression, setTopicExpression, None, 'TopicExpression element')

    def getUseNotify(self):
        return self._element._UseNotify
    def setUseNotify(self, value):
        assert type(value) is bool, 'expecting boolean for UseNotify value.'
        self._element._UseNotify = value
    UseNotify = property(getUseNotify, setUseNotify, None, 'UseNotify element')

