############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import ZSI.TC
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.properties.ResourceProperties import ResourceProperties
from pyGridWare.generated.types import GetNSContainer
import pyGridWare.generated.types.WidgetService_services_types

_TARGETNAMESPACE = "http://widgets.com"
_widget = \
    GetNSContainer(pyGridWare.generated.types.WidgetService_services_types,
         _TARGETNAMESPACE)
_lifetime_prop = \
     GetNSContainer(pyGridWare.generated.types.WidgetService_services_types,
         'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime-1.2-draft-01.xsd')


class WidgetKey(int):
    typecode = ZSI.TC.Iint(pname=(_TARGETNAMESPACE,'ResourceID'))


class WidgetProperties(ResourceProperties):
    declaration = _lifetime_prop.ScheduledResourceTerminationRP_Dec

    def __init__(self):
        ResourceProperties.__init__(self)

    def getTopicExpression(self):
        return self._element._TopicExpression
    def setTopicExpression(self, value): 
        #assert isinstance(value, , 'expecting boolean for UseNotify value.'
        self._element._TopicExpression = value
    TopicExpression = property(getTopicExpression, setTopicExpression, None, 'TopicExpression element')

    def getUseNotify(self):
        return self._element._UseNotify
    def setUseNotify(self, value):
        assert type(value) is bool, 'expecting boolean for UseNotify value.'
        self._element._UseNotify = value
    UseNotify = property(getUseNotify, setUseNotify, None, 'UseNotify element')

