############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.resource.ResourceContext import ResourceContext
from pyGridWare.addressing.AddressingUtils import AddressingUtils
from pyGridWare.generated.properties.Counter_properties import \
    CounterKey,CounterProperties


class CounterHome(PersistentResourceHome):

    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, CounterKey.typecode)
        return self.get(key)


class CounterContext(ResourceContext):
    home = CounterHome()

    def __init__(self):
        ResourceContext.__init__(self)
        self.properties = CounterProperties()

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, CounterKey(resourceID))

