############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
import time
from ZSI.wstools.Namespaces import OASIS
from pyGridWare.resource.ResourceHome import PersistentResourceHome
from pyGridWare.resource.ResourceContext import ResourceContext

from pyGridWare.generated.properties.WidgetService_properties import \
    WidgetProperties, WidgetKey
from pyGridWare.addressing.AddressingUtils import AddressingUtils

class WidgetManagerHome(PersistentResourceHome):

    def getResourceContext(self, ps, address):
        key = AddressingUtils.getResourceID(ps, WidgetKey.typecode)
        return self.get(key)


class WidgetContext(ResourceContext):
    home = WidgetManagerHome()

    def __init__(self):
        ResourceContext.__init__(self)
        self.properties = WidgetProperties()

    def setResourceID(self, resourceID):
        ResourceContext.setResourceID(self, WidgetKey(resourceID))

