from pyGridWare.generated.stubs.Counter_services import *
from pyGridWare.wsrf.resource import WSResource

class Counter(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty': 'wsa_GetResourceProperty',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessage': 'wsa_GetCurrentMessage',
        'http://counter.com/CounterPortType/createCounterRequest': 'wsa_createCounter',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/Subscribe': 'wsa_Subscribe',
        'http://counter.com/CounterPortType/addRequest': 'wsa_add',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime': 'wsa_SetTerminationTime',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy': 'wsa_Destroy',
        }
    wsAction = {
        'wsa_GetResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse',
        'wsa_GetCurrentMessage': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/GetCurrentMessageResponse',
        'wsa_createCounter': 'http://counter.com/CounterPortType/createCounterResponse',
        'wsa_Subscribe': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/SubscribeResponse',
        'wsa_add': 'http://counter.com/CounterPortType/addResponse',
        'wsa_SetTerminationTime': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse',
        'wsa_Destroy': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse',
        }

    def __init__(self, post='/wsrf/services/', **kw):
        WSResource.__init__(self, post)

    def wsa_Destroy(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(DestroyRequest.typecode)

        # assign return values to response object
        response = DestroyResponse()

        return response

    def wsa_GetCurrentMessage(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetCurrentMessageRequest.typecode)

        # assign return values to response object
        response = GetCurrentMessageResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest.typecode)

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_SetTerminationTime(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SetTerminationTimeRequest.typecode)

        # assign return values to response object
        response = SetTerminationTimeResponse()

        return response

    def wsa_Subscribe(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SubscribeRequest.typecode)

        # assign return values to response object
        response = SubscribeResponse()

        return response

    def wsa_add(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(AddInputMessage.typecode)

        # assign return values to response object
        response = AddOutputMessage()

        return response

    def wsa_createCounter(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(CreateCounterRequest.typecode)

        # assign return values to response object
        response = CreateCounterResponse()

        return response
