from pyGridWare.generated.stubs.SubscriptionManagerService_services import *
from pyGridWare.wsrf.resource import WSResource

class SubscriptionManagerService(WSResource):
    soapAction = {
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourceProperty': 'wsa_GetResourceProperty',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/Destroy': 'wsa_Destroy',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscription': 'wsa_ResumeSubscription',
        'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscription': 'wsa_PauseSubscription',
        'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTime': 'wsa_SetTerminationTime',
        }
    wsAction = {
        'wsa_GetResourceProperty': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceProperties/GetResourcePropertyResponse',
        'wsa_Destroy': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/DestroyResponse',
        'wsa_ResumeSubscription': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/ResumeSubscriptionResponse',
        'wsa_PauseSubscription': 'http://docs.oasis-open.org/wsn/2004/06/wsn-WS-BaseNotification/PauseSubscriptionResponse',
        'wsa_SetTerminationTime': 'http://docs.oasis-open.org/wsrf/2004/06/wsrf-WS-ResourceLifetime/SetTerminationTimeResponse',
        }

    def __init__(self, post='/wsrf/services/', **kw):
        WSResource.__init__(self, post)

    def wsa_Destroy(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(DestroyRequest.typecode)

        # assign return values to response object
        response = DestroyResponse()

        return response

    def wsa_GetResourceProperty(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(GetResourcePropertyRequest.typecode)

        # assign return values to response object
        response = GetResourcePropertyResponse()

        return response

    def wsa_PauseSubscription(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(PauseSubscriptionRequest.typecode)

        # assign return values to response object
        response = PauseSubscriptionResponse()

        return response

    def wsa_ResumeSubscription(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(ResumeSubscriptionRequest.typecode)

        # assign return values to response object
        response = ResumeSubscriptionResponse()

        return response

    def wsa_SetTerminationTime(self, ps, address):
        # input vals in request object
        self.request = ps.Parse(SetTerminationTimeRequest.typecode)

        # assign return values to response object
        response = SetTerminationTimeResponse()

        return response
