############################################################################
# Joshua R. Boverhof, LBNL
# See Copyright for copyright notice!
###########################################################################
__all__ = [\
]
import ZSI as _ZSI
from ZSI.generate.utility import ElementDeclaration as _ElementDeclaration
from ZSI.generate.utility import TypeDefinition as _TypeDefinition


def GetNSContainer(module, targetNamespace):
    ns_class = None
    for ns_class in module.__dict__.values():
        tns = getattr(ns_class, 'targetNamespace', None) 
        if tns is None: continue
        if tns == targetNamespace: break
    else:
        raise RuntimeError, 'can not find targetNamespace(%s) in module(%s)' %(targetNamespace, module)
    return ns_class

"""
class _gram_job:
    targetNamespace = "http://www.globus.org/namespaces/2004/10/gram/job"
    
    class CreateManagedJobInputType_Def(_ZSI.TCcompound.Struct, _TypeDefinition):
        schema = "http://www.globus.org/namespaces/2004/10/gram/job"
        type = (schema, "CreateManagedJobInputType")
        attribute_typecode_dict = {}
        def __init__(self, pname, **kw):
            ns = _gram_job.CreateManagedJobInputType_Def.schema
            TClist = [_ZSI.TCtimes.gDateTime(pname="InitialTerminationTime", aname="_InitialTerminationTime", minOccurs=0, maxOccurs=1, nillable=1), _ns4.AttributedURI_Def(pname="JobID", aname="_JobID", minOccurs=0, maxOccurs=1, nillable=0), _ns22.Subscribe_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns19.job_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns19.multiJob_Dec(minOccurs=0, maxOccurs=1, nillable=0)]
            class Holder:
                typecode = self 
                def __init__(self):
                    # pyclass
                    self._InitialTerminationTime = None
                    self._JobID = None
                    self._Subscribe = None
                    self._job = None
                    self._multiJob = None
                    return
            _ZSI.TCcompound.Struct.__init__(self, Holder, TClist, pname=pname, inorder=0, **kw)

import ManagedJobFactory_services_types as _ManagedJobFactory_services_types
_ns4 = GetNSContainer(ManagedJobFactory_services_types, 
          "http://schemas.xmlsoap.org/ws/2004/03/addressing")
_ns19 = GetNSContainer(ManagedJobFactory_services_types, 
          "http://www.globus.org/namespaces/2004/10/gram/job/description")
_ns22 = GetNSContainer(ManagedJobFactory_services_types, 
          "http://www.globus.org/namespaces/2004/10/gram/job")
"""

class _ns_address:
    targetNamespace = 'http://schemas.xmlsoap.org/ws/2004/03/addressing'

    class ReferenceParametersType_Def(_ZSI.TC.Struct, _TypeDefinition):
        """BUG This type is not defined in ws-addressing, but it's being used.
        """
        #<wsa:ReferenceParameters xsi:type="wsa:ReferenceParametersType"/>
        schema = 'http://schemas.xmlsoap.org/ws/2004/03/addressing'
        type = (schema, "ReferenceParametersType")

        def __init__(self, pname, **kw):
            _ZSI.TC.Struct.__init__(self, self.__class__, [], pname=pname, inorder=0, **kw)

class _xmldsig:
    targetNamespace = "http://www.w3.org/2000/09/xmldsig#"
   
    class KeyInfoType_Def(_ZSI.TCcompound.Struct, _TypeDefinition):
        schema = "http://www.w3.org/2000/09/xmldsig#"
        type = (schema, "KeyInfoType")
        attribute_typecode_dict = {}
        def __init__(self, pname, **kw):
            self._KeyName = None
            self._KeyValue = None
            self._RetrievalMethod = None
            self._X509Data = None
            self._PGPData = None
            self._SPKIData = None
            self._MgmtData = None
            ns = _ns3.KeyInfoType_Def.schema
            TClist = [_ns3.KeyName_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.KeyValue_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.RetrievalMethod_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.X509Data_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.PGPData_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.SPKIData_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ns3.MgmtData_Dec(minOccurs=0, maxOccurs=1, nillable=0), _ZSI.TC.AnyElement(aname="_any", minOccurs=0, maxOccurs=1, nillable=0)]
            _ZSI.TCcompound.Struct.__init__(self, self.__class__, TClist, pname=pname, inorder=0, mixed=True, mixed_aname="_text", **kw)
            # attribute handling code
            self.mixed = True
            self._attrs = {}
            self.attribute_typecode_dict.update(_ns3.KeyInfoType_Def.attribute_typecode_dict)
            self.attribute_typecode_dict["Id"] = _ZSI.TC.AnyType()
            setattr(self, self.attrs_aname, {})

import SecureConversation_services_types as _SecureConversation_services_types
_ns3 = GetNSContainer(_SecureConversation_services_types, "http://www.w3.org/2000/09/xmldsig#")


"""
# Patches for Unions
class _ns_trust:
    targetNamespace = 'http://schemas.xmlsoap.org/ws/2004/04/trust'

    # JRB NOT GENERATED BECAUSE OF UNION
    class RequestTypeOpenEnum_Def(_ZSI.TC.URI):
        # <xs:simpleType name='RequestTypeOpenEnum' >
        #  <xs:union memberTypes='wst:RequestTypeEnum xs:anyURI' />
        # </xs:simpleType>
        schema = 'http://schemas.xmlsoap.org/ws/2004/04/trust'
        type = (schema,'RequestTypeOpenEnum')

        def __init__(self, pname, **kw):
            _ZSI.TC.URI.__init__(self, pname, **kw)


    # JRB NOT GENERATED BECAUSE OF UNION
    class RequestType_Dec(RequestTypeOpenEnum_Def, _ElementDeclaration):
        #  <xs:element name='RequestType' type='wst:RequestTypeOpenEnum' />
        schema = 'http://schemas.xmlsoap.org/ws/2004/04/trust'
        literal = 'RequestType'
    
        def __init__(self, **kw):
            pname = self.get_pname()
            _ns_trust.RequestTypeOpenEnum_Def.__init__(self, pname=pname, **kw)


trust_class = GetNSContainer(_SecureConversation_services_types, 'http://schemas.xmlsoap.org/ws/2004/04/trust')
#_SecureConversation_services_types.schemas_xmlsoap_org_ws_2004_04_trust.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict = {}
trust_class.BinaryExchangeType_Def.attribute_typecode_dict['ValueType'] = _ZSI.TC.URI()
trust_class.BinaryExchangeType_Def.attribute_typecode_dict['EncodingType'] = _ZSI.TC.URI()
trust_class.BinaryExchangeType_Def.attribute_typecode_dict[("http://www.w3.org/2001/XMLSchema","anyAttribute")] = _ZSI.TC.AnyElement()
trust_class.RequestTypeOpenEnum_Def = _ns_trust.RequestTypeOpenEnum_Def
trust_class.RequestType_Dec = _ns_trust.RequestType_Dec
"""
