############################################################################
# Joshua R. Boverhof, LBNL
# See LBNLCopyright for copyright notice!
###########################################################################
import ZSI.TC
from ZSI.wstools.Namespaces import OASIS
from pyGridWare.services.CounterService import Counter
from pyGridWare.security.gss.GssService import GssSecureResourceMixIn
from pyGridWare.security.Utility import MessageSigUtility


class SecureCounter(GssSecureResourceMixIn, Counter):

    def __init__(self, post='/wsrf/services/SecureCounterService', **kw):
        Counter.__init__(self, post)
        GssSecureResourceMixIn.__init__(self, post)
    #def __signResponse(self, response):
    #    # Specify Signature over response
    #    if response.typecode.attribute_typecode_dict is None:
    #        response.typecode.attribute_typecode_dict = {}
    #    response.typecode.attribute_typecode_dict[(OASIS.UTILITY,"Id")] = ZSI.TC.String()
    #   aname = response.typecode.attrs_aname
    #   if hasattr(response, aname) is False:
    #       setattr(response, aname, {})
    #   getattr(response, aname)[(OASIS.UTILITY,"Id")] = "digestSource"

    def wsa_Destroy(self, ps, address):
        response = Counter.wsa_Destroy(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_GetCurrentMessage(self, ps, address):
        response = Counter.wsa_GetCurrentMessage(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_GetResourceProperty(self, ps, address):
        response = Counter.wsa_GetResourceProperty(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_SetTerminationTime(self, ps, address):
        # Get request and response
        response = Counter.wsa_SetTerminationTime(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_Subscribe(self, ps, address):
        response = Counter.wsa_Subscribe(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_add(self, ps, address):
        response = Counter.wsa_add(self, ps, address)
        MessageSigUtility.Sign(response)
        return response

    def wsa_createCounter(self, ps, address):
        # Get request and response
        response = Counter.wsa_createCounter(self, ps, address)
        MessageSigUtility.Sign(response)
        return response


